// test loop identification, back edge breaking

void noloop(char *a)
{
  do {
    a++;
  } while (0);
}

void basic(char *a)
{
  a++;
  while (*a) {
    a++;
  }
}

void gotos(char *a)
{
 L:
  a++;
  if (*a)
    goto L;
}

void nested(char *a)
{
  while (*a) {
    while (*a) {
      a++;
    }
    a++;
  }
}

void irreducible(char *a, int b)
{
  if (b) {
    goto L;
  }

  while (*a) {
    a++;
    L:
    a++;
  }
}

void deeper_nested(char *a)
{
  while (*a) {
    while (*a) {
      while (*a) {
      }
    }
    while (*a) {
    }
  }
}

void complex(char *a)
{
  a++;
  while (*a) {
    if (*a) goto L;
  }
  a++;
 L:
  a++;
}

// this is a degenerate case that isn't handled correctly at the moment.
// it's not even clear how this SHOULD be handled, given that there's no
// actual instructions and thus no actual CFG
void loopforever(char *a)
{
  while (1) {}
}

typedef struct Buffer {
 unsigned char *buf;
 unsigned int alloc;
 unsigned int offset;
 unsigned int end;
} Buffer;

// openssh/buffer.c
void *buffer_append_space(Buffer *buffer, unsigned int len)
{
	unsigned int newlen;
	void *p;

	if (len > 0x100000)
		fatal("buffer_append_space: len %u not supported", len);

	if (buffer->offset == buffer->end) {
		buffer->offset = 0;
		buffer->end = 0;
	}
restart:
	if (buffer->end + len < buffer->alloc) {
		p = buffer->buf + buffer->end;
		buffer->end += len;
		return p;
	}
	if (buffer->offset > buffer->alloc / 2) {
		memmove(buffer->buf, buffer->buf + buffer->offset,
			buffer->end - buffer->offset);
		buffer->end -= buffer->offset;
		buffer->offset = 0;
		goto restart;
	}
	newlen = buffer->alloc + len + 32768;
	if (newlen > 0xa00000)
		fatal("buffer_append_space: alloc %u not supported",
		    newlen);
	buffer->buf = xrealloc(buffer->buf, newlen);
	buffer->alloc = newlen;
	goto restart;
}
